__doc__ = """\
: AqGuard
: Tue Dec 18 12:38:16 MSK 2001
:    (c) 2001
c: $Id: AqGuard.py,v 1.13 2002/01/25 14:55:00 cray Exp $

:
        AqGuard.py

:
        ,     ,
	  URL'.  . .

	      
	IIGFS,       .
"""
__version__ = '$Revision: 1.13 $'[8:-1]

from Globals import HTMLFile      
from Globals import MessageDialog 
from Globals import Persistent    
from Globals import default__class_init__

import OFS.SimpleItem
import Acquisition
import AccessControl.Role
import Products

try :
	from Products.IIGFS.PropertyManager import PropertyManager
except :
	from OFS.PropertyManager import PropertyManager
from Products.SiteAccess.SiteRoot import Traverser

import re
import string
manage_addAqGuardForm = HTMLFile('dtml/AqGuardAdd', globals()) 

AqGuardBlocked = 'AqGuardBlocked'
NotFound = 'NotFound'

def manage_addAqGuard(self, id, title=None, REQUEST=None):
    """  AqGuard """
    ob = AqGuard(id)
    self._setObject(id, ob)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

def ifret(cond,s1,s2) :
	if cond :
		return s1
	else :
		return s2

class AqGuard(
    Traverser,
    PropertyManager,
    OFS.SimpleItem.Item,   
    Persistent,            
    Acquisition.Implicit,  
    AccessControl.Role.RoleManager 
    ): 
    """      ."""
        
    meta_type = 'AqGuard' 

# PropertyManager.manage_options
    manage_options =  ( 
	{'label': '',       		'action': 'manage_propertiesForm', 'help':('AqGuard','AqGuard_Properties.stx')}, 
    ) 


    use_listed_objects = ''
    use_name_filter = 'on'
    use_aqguard = ''
    max_repeats = 4
    fuck_name = ''

    _properties = PropertyManager._properties + (
        {'id':'use_aqguard', 'name':'', 'type':'boolean', 'mode':'w'},
        {'id':'use_name_filter', 'name':'  ', 'type':'boolean', 'mode':'w'},
        {'id':'use_listed_objects', 'name':'  ', 'type':'boolean', 'mode':'w'},
        {'id':'max_repeats', 'name':'  ', 'type':'int', 'mode':'w'},
        {'id':'fuck_name', 'name':'   ', 'type':'string', 'mode':'w'},
	{'id':'paths', 'name':' ', 'type':'tokens', 'mode':'w'}
    )

    def __init__(self, id, title='') :  
        """initialise a new instance of AqGuard"""
        self.id = id
        self.title = title
	self.paths  = []

    def manage_tunning(self,REQUEST=None) :
	"""   """
	pass

    def discard(self,item) :
	s = string.strip(self.fuck_name)
	if s :
	    try :
		method = self.restrictedTraverse(s)
	    except AttributeError :
		raise AqGuardBlocked,' %s    %u ,   %s -  ' % (item,self.max_repeats,s)
	    else :
		raise AqGuardBlocked,method(self.getPhysicalRoot(),self.REQUEST)##method,
	raise AqGuardBlocked,' %s    %u ' % (item,self.max_repeats)

    def __call__(self,client,REQUEST,RESPONSE=None) :
	ols = {}
	if self.use_aqguard :
	    if self.use_name_filter :
		for item in string.split(REQUEST['PATH_INFO'],'/') :
			if (self.use_listed_objects != '') == (item in self.paths) :
			    try :
				ols[item] = ols[item] + 1
			    except KeyError :
				ols[item] = 1

			    if ols[item] > self.max_repeats :
				self.discard(item)
	    else :
		ob = self
		self_id = self.absolute_url(1)
		r = {}
		id = "" 
		for item in string.split(REQUEST['PATH_INFO'],'/') :
			if item :
				if hasattr(ob,'__bobo_traverse__') :
					ob = ob.__bobo_traverse__(r,item)
				else :
					try :
						ob = getattr(ob,item)
					except AttributeError :
						try :
							ob = ob[item]
						except KeyError :
							return
						except AttributeError :
							print ' !',item
							return


				try :
					id = ob.absolute_url(1)
				except AttributeError :
					id = id + '/' + item

				if (self.use_listed_objects != '') == (item in self.paths) :
					try :
				    		ols[(id,item)] = ols[(id,item)] + 1
		        		except KeyError :
		     				ols[(id,item)] = 1

			        	if ols[(id,item)] > self.max_repeats :
				    		self.discard(item)

default__class_init__ (AqGuard)
